searchData={"items":[{"type":"module","title":"Zenohex","doc":"Documentation for `Elixir.Zenohex`.","ref":"Zenohex.html"},{"type":"function","title":"Zenohex.open/1","doc":"Open a zenoh Session.","ref":"Zenohex.html#open/1"},{"type":"function","title":"Examples - Zenohex.open/1","doc":"iex> Zenohex.open()","ref":"Zenohex.html#open/1-examples"},{"type":"function","title":"Zenohex.open!/1","doc":"Open a zenoh Session.","ref":"Zenohex.html#open!/1"},{"type":"function","title":"Examples - Zenohex.open!/1","doc":"iex> Zenohex.open!()","ref":"Zenohex.html#open!/1-examples"},{"type":"module","title":"Zenohex.KeyExpr","doc":"Documentation for `Elixir.Zenohex.KeyExpr`.","ref":"Zenohex.KeyExpr.html"},{"type":"function","title":"Zenohex.KeyExpr.intersects?/2","doc":"Returns true if the keyexprs intersect.  \ni.e. there exists at least one key which is contained in both of the sets defined by key_expr1 and key_expr2.","ref":"Zenohex.KeyExpr.html#intersects?/2"},{"type":"module","title":"Zenohex.Publisher","doc":"Documentation for `Elixir.Zenohex.Publisher`.","ref":"Zenohex.Publisher.html"},{"type":"function","title":"Zenohex.Publisher.congestion_control/2","doc":"Change the congestion_control to apply when routing the data.","ref":"Zenohex.Publisher.html#congestion_control/2"},{"type":"function","title":"Examples - Zenohex.Publisher.congestion_control/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, publisher} = Zenohex.Session.declare_publisher(session, \"key/expression\")\n    iex> Zenohex.Publisher.congestion_control(publisher, :drop)","ref":"Zenohex.Publisher.html#congestion_control/2-examples"},{"type":"function","title":"Zenohex.Publisher.delete/1","doc":"Delete data.","ref":"Zenohex.Publisher.html#delete/1"},{"type":"function","title":"Examples - Zenohex.Publisher.delete/1","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, publisher} = Zenohex.Session.declare_publisher(session, \"key/expression\")\n    iex> :ok = Zenohex.Publisher.delete(publisher)","ref":"Zenohex.Publisher.html#delete/1-examples"},{"type":"function","title":"Zenohex.Publisher.priority/2","doc":"Change the priority of the written data.","ref":"Zenohex.Publisher.html#priority/2"},{"type":"function","title":"Examples - Zenohex.Publisher.priority/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, publisher} = Zenohex.Session.declare_publisher(session, \"key/expression\")\n    iex> Zenohex.Publisher.priority(publisher, :real_time)","ref":"Zenohex.Publisher.html#priority/2-examples"},{"type":"function","title":"Zenohex.Publisher.put/2","doc":"Put data.","ref":"Zenohex.Publisher.html#put/2"},{"type":"function","title":"Examples - Zenohex.Publisher.put/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, publisher} = Zenohex.Session.declare_publisher(session, \"key/expression\")\n    iex> :ok = Zenohex.Publisher.put(publisher, \"value\")\n    iex> :ok = Zenohex.Publisher.put(publisher, 0)\n    iex> :ok = Zenohex.Publisher.put(publisher, 0.0)","ref":"Zenohex.Publisher.html#put/2-examples"},{"type":"type","title":"Zenohex.Publisher.t/0","doc":"","ref":"Zenohex.Publisher.html#t:t/0"},{"type":"module","title":"Zenohex.PullSubscriber","doc":"Documentation for `Elixir.Zenohex.PullSubscriber`.","ref":"Zenohex.PullSubscriber.html"},{"type":"function","title":"Zenohex.PullSubscriber.pull/1","doc":"Pull data.","ref":"Zenohex.PullSubscriber.html#pull/1"},{"type":"function","title":"Examples - Zenohex.PullSubscriber.pull/1","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, pull_subscriber} = Zenohex.Session.declare_pull_subscriber(session, \"key/expression\")\n    iex> Zenohex.PullSubscriber.pull(pull_subscriber)\n    :ok","ref":"Zenohex.PullSubscriber.html#pull/1-examples"},{"type":"function","title":"Zenohex.PullSubscriber.recv_timeout/2","doc":"Receive data.\nNormally users don't need to change the default timeout_us.","ref":"Zenohex.PullSubscriber.html#recv_timeout/2"},{"type":"function","title":"Examples - Zenohex.PullSubscriber.recv_timeout/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, pull_subscriber} = Zenohex.Session.declare_pull_subscriber(session, \"key/expression\")\n    iex> Zenohex.PullSubscriber.recv_timeout(pull_subscriber)\n    {:error, :timeout}","ref":"Zenohex.PullSubscriber.html#recv_timeout/2-examples"},{"type":"type","title":"Zenohex.PullSubscriber.t/0","doc":"","ref":"Zenohex.PullSubscriber.html#t:t/0"},{"type":"module","title":"Zenohex.Query","doc":"Documentation for `Elixir.Zenohex.Query`.\n\nStructs received by a `Zenohex.Queryable.recv_timeout/1`.","ref":"Zenohex.Query.html"},{"type":"function","title":"Zenohex.Query.finish_reply/1","doc":"Finish reply.\n\n> #","ref":"Zenohex.Query.html#finish_reply/1"},{"type":"function","title":"Warning {: .warning} - Zenohex.Query.finish_reply/1","doc":"> `finish_reply/1` must be called after `reply/2`.","ref":"Zenohex.Query.html#finish_reply/1-warning-warning"},{"type":"function","title":"Zenohex.Query.reply/2","doc":"Sends a reply to this Query. User can call `reply/2` multiple times to send multiple samples.\n\n> #","ref":"Zenohex.Query.html#reply/2"},{"type":"function","title":"Warning {: .warning} - Zenohex.Query.reply/2","doc":"> Do not forget to call `finish_reply/1` to finish the reply.","ref":"Zenohex.Query.html#reply/2-warning-warning"},{"type":"type","title":"Zenohex.Query.t/0","doc":"","ref":"Zenohex.Query.html#t:t/0"},{"type":"module","title":"Zenohex.Queryable","doc":"Documentation for `Elixir.Zenohex.Queryable`.","ref":"Zenohex.Queryable.html"},{"type":"function","title":"Zenohex.Queryable.recv_timeout/2","doc":"Receive query.\nNormally users don't need to change the default timeout_us.","ref":"Zenohex.Queryable.html#recv_timeout/2"},{"type":"function","title":"Examples - Zenohex.Queryable.recv_timeout/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, queryable} = Zenohex.Session.declare_queryable(session, \"key/expression\")\n    iex> Zenohex.Queryable.recv_timeout(queryable)\n    {:error, :timeout}","ref":"Zenohex.Queryable.html#recv_timeout/2-examples"},{"type":"type","title":"Zenohex.Queryable.t/0","doc":"","ref":"Zenohex.Queryable.html#t:t/0"},{"type":"module","title":"Zenohex.Sample","doc":"Documentation for `Elixir.Zenohex.Sample`.\n\nStructs received by\n\n  * `Zenohex.Session.get_timeout/3` and `Zenohex.Session.get_reply_timeout/1`\n  * `Zenohex.Subscriber.recv_timeout/1`\n  * `Zenohex.PullSubscriber.recv_timeout/1`","ref":"Zenohex.Sample.html"},{"type":"type","title":"Zenohex.Sample.t/0","doc":"","ref":"Zenohex.Sample.html#t:t/0"},{"type":"module","title":"Zenohex.Session","doc":"Documentation for `Elixir.Zenohex.Session`.","ref":"Zenohex.Session.html"},{"type":"function","title":"Zenohex.Session.declare_publisher/3","doc":"Create a Publisher for the given key expression.","ref":"Zenohex.Session.html#declare_publisher/3"},{"type":"function","title":"Examples - Zenohex.Session.declare_publisher/3","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> Zenohex.Session.declare_publisher(session, \"key/expression\")","ref":"Zenohex.Session.html#declare_publisher/3-examples"},{"type":"function","title":"Zenohex.Session.declare_pull_subscriber/3","doc":"Create a PullSubscriber for the given key expression.","ref":"Zenohex.Session.html#declare_pull_subscriber/3"},{"type":"function","title":"Examples - Zenohex.Session.declare_pull_subscriber/3","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> Zenohex.Session.declare_pull_subscriber(session, \"key/expression\")","ref":"Zenohex.Session.html#declare_pull_subscriber/3-examples"},{"type":"function","title":"Zenohex.Session.declare_queryable/3","doc":"Create a Quaryable for the given key expression.","ref":"Zenohex.Session.html#declare_queryable/3"},{"type":"function","title":"Examples - Zenohex.Session.declare_queryable/3","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> Zenohex.Session.declare_queryable(session, \"key/expression\")","ref":"Zenohex.Session.html#declare_queryable/3-examples"},{"type":"function","title":"Zenohex.Session.declare_subscriber/3","doc":"Create a Subscriber for the given key expression.","ref":"Zenohex.Session.html#declare_subscriber/3"},{"type":"function","title":"Examples - Zenohex.Session.declare_subscriber/3","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> Zenohex.Session.declare_subscriber(session, \"key/expression\")","ref":"Zenohex.Session.html#declare_subscriber/3-examples"},{"type":"function","title":"Zenohex.Session.delete/2","doc":"Delete data.","ref":"Zenohex.Session.html#delete/2"},{"type":"function","title":"Examples - Zenohex.Session.delete/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> Zenohex.Session.delete(session, \"key/expression\")\n    :ok","ref":"Zenohex.Session.html#delete/2-examples"},{"type":"function","title":"Zenohex.Session.get_reply_receiver/3","doc":"Get reply receiver from the matching queryables in the system.","ref":"Zenohex.Session.html#get_reply_receiver/3"},{"type":"function","title":"Examples - Zenohex.Session.get_reply_receiver/3","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> Zenohex.Session.get_reply_receiver(session, \"key/**\")","ref":"Zenohex.Session.html#get_reply_receiver/3-examples"},{"type":"function","title":"Zenohex.Session.get_reply_timeout/2","doc":"Query data from receiver.\nNormally users don't need to change the default timeout_us.","ref":"Zenohex.Session.html#get_reply_timeout/2"},{"type":"function","title":"Examples - Zenohex.Session.get_reply_timeout/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, receiver} = Zenohex.Session.get_reply_receiver(session, \"key/**\")\n    iex> Zenohex.Session.get_reply_timeout(receiver)\n    {:error, :disconnected}","ref":"Zenohex.Session.html#get_reply_timeout/2-examples"},{"type":"function","title":"Zenohex.Session.get_timeout/4","doc":"Get one data from the matching queryables in the system.  \nTo get multiple data, use `get_reply_receiver/2` and `get_reply_timeout/1` instead.","ref":"Zenohex.Session.html#get_timeout/4"},{"type":"function","title":"Examples - Zenohex.Session.get_timeout/4","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> Zenohex.Session.get_timeout(session, \"key/expression\", 1000)\n    {:error, :disconnected}","ref":"Zenohex.Session.html#get_timeout/4-examples"},{"type":"function","title":"Zenohex.Session.put/3","doc":"Put data.","ref":"Zenohex.Session.html#put/3"},{"type":"function","title":"Examples - Zenohex.Session.put/3","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> :ok = Zenohex.Session.put(session, \"key/expression\", \"value\")\n    iex> :ok = Zenohex.Session.put(session, \"key/expression\", 0)\n    iex> :ok = Zenohex.Session.put(session, \"key/expression\", 0.0)","ref":"Zenohex.Session.html#put/3-examples"},{"type":"type","title":"Zenohex.Session.receiver/0","doc":"","ref":"Zenohex.Session.html#t:receiver/0"},{"type":"type","title":"Zenohex.Session.t/0","doc":"","ref":"Zenohex.Session.html#t:t/0"},{"type":"module","title":"Zenohex.Subscriber","doc":"Documentation for `Elixir.Zenohex.Subscriber`.","ref":"Zenohex.Subscriber.html"},{"type":"function","title":"Zenohex.Subscriber.recv_timeout/2","doc":"Receive data.\nNormally users don't need to change the default timeout_us.","ref":"Zenohex.Subscriber.html#recv_timeout/2"},{"type":"function","title":"Examples - Zenohex.Subscriber.recv_timeout/2","doc":"iex> {:ok, session} = Zenohex.open()\n    iex> {:ok, subscriber} = Zenohex.Session.declare_subscriber(session, \"key/expression\")\n    iex> Zenohex.Subscriber.recv_timeout(subscriber)\n    {:error, :timeout}","ref":"Zenohex.Subscriber.html#recv_timeout/2-examples"},{"type":"opaque","title":"Zenohex.Subscriber.t/0","doc":"","ref":"Zenohex.Subscriber.html#t:t/0"},{"type":"module","title":"Zenohex.Config","doc":"Documentation for `Elixir.Zenohex.Config`.\n\nUsed by `Zenohex.open/1`, `Zenohex.open!/1`.","ref":"Zenohex.Config.html"},{"type":"type","title":"Zenohex.Config.t/0","doc":"","ref":"Zenohex.Config.html#t:t/0"},{"type":"module","title":"Zenohex.Config.Connect","doc":"Documentation for `Elixir.Zenohex.Config.Connect`.","ref":"Zenohex.Config.Connect.html"},{"type":"type","title":"Zenohex.Config.Connect.endpoints/0","doc":"ex. [\"tcp/192.168.1.1:7447\", \"tcp/192.168.1.2:7447\"]","ref":"Zenohex.Config.Connect.html#t:endpoints/0"},{"type":"type","title":"Zenohex.Config.Connect.t/0","doc":"","ref":"Zenohex.Config.Connect.html#t:t/0"},{"type":"module","title":"Zenohex.Config.Scouting","doc":"Documentation for `Elixir.Zenohex.Config.Scouting`.","ref":"Zenohex.Config.Scouting.html"},{"type":"type","title":"Zenohex.Config.Scouting.delay/0","doc":"In peer mode, the period dedicated to scouting remote peers before attempting other operations. In milliseconds.","ref":"Zenohex.Config.Scouting.html#t:delay/0"},{"type":"type","title":"Zenohex.Config.Scouting.t/0","doc":"","ref":"Zenohex.Config.Scouting.html#t:t/0"},{"type":"module","title":"Zenohex.Publisher.Options","doc":"Documentation for `Elixir.Zenohex.Publisher.Options`.\n\nUsed by `Zenohex.Session.declare_publisher/3`.","ref":"Zenohex.Publisher.Options.html"},{"type":"type","title":"Zenohex.Publisher.Options.congestion_control/0","doc":"","ref":"Zenohex.Publisher.Options.html#t:congestion_control/0"},{"type":"type","title":"Zenohex.Publisher.Options.priority/0","doc":"","ref":"Zenohex.Publisher.Options.html#t:priority/0"},{"type":"type","title":"Zenohex.Publisher.Options.t/0","doc":"","ref":"Zenohex.Publisher.Options.html#t:t/0"},{"type":"module","title":"Zenohex.Query.Options","doc":"Documentation for `Elixir.Zenohex.Query.Options`.\n\nUsed by `Zenohex.Session.get_timeout/4` and `Zenohex.Session.get_reply_receiver/3`.","ref":"Zenohex.Query.Options.html"},{"type":"type","title":"Zenohex.Query.Options.consolidation/0","doc":"","ref":"Zenohex.Query.Options.html#t:consolidation/0"},{"type":"type","title":"Zenohex.Query.Options.t/0","doc":"","ref":"Zenohex.Query.Options.html#t:t/0"},{"type":"type","title":"Zenohex.Query.Options.target/0","doc":"","ref":"Zenohex.Query.Options.html#t:target/0"},{"type":"module","title":"Zenohex.Queryable.Options","doc":"Documentation for `Elixir.Zenohex.Queryable.Options`.\n\nUsed by `Zenohex.Session.declare_queryable/3`.","ref":"Zenohex.Queryable.Options.html"},{"type":"type","title":"Zenohex.Queryable.Options.complete/0","doc":"","ref":"Zenohex.Queryable.Options.html#t:complete/0"},{"type":"type","title":"Zenohex.Queryable.Options.t/0","doc":"","ref":"Zenohex.Queryable.Options.html#t:t/0"},{"type":"module","title":"Zenohex.Subscriber.Options","doc":"Documentation for `Elixir.Zenohex.Subscriber.Options`.\n\nUsed by `Zenohex.Session.declare_subscriber/3` and `Zenohex.Session.declare_pull_subscriber/3`.","ref":"Zenohex.Subscriber.Options.html"},{"type":"type","title":"Zenohex.Subscriber.Options.reliability/0","doc":"","ref":"Zenohex.Subscriber.Options.html#t:reliability/0"},{"type":"type","title":"Zenohex.Subscriber.Options.t/0","doc":"","ref":"Zenohex.Subscriber.Options.html#t:t/0"},{"type":"extras","title":"Zenohex","doc":"# Zenohex\n\n[![Hex version](https://img.shields.io/hexpm/v/zenohex.svg \"Hex version\")](https://hex.pm/packages/zenohex)\n[![API docs](https://img.shields.io/hexpm/v/zenohex.svg?label=hexdocs \"API docs\")](https://hexdocs.pm/zenohex/)\n[![License](https://img.shields.io/hexpm/l/zenohex.svg)](https://github.com/zenohex/zenohex/blob/main/LICENSE)\n[![CI](https://github.com/b5g-ex/zenohex/actions/workflows/ci.yml/badge.svg)](https://github.com/b5g-ex/zenohex/actions/workflows/ci.yml)\n\nZenohex is Elixir API for [Zenoh](https://zenoh.io/).\n\nZenoh is a new protocol for Zero Overhead Pub/Sub, Store/Query and Compute.\nThe most obvious explanation is that Zenoh offers publication subscription-based communication capabilities.\nWithin the same network, Zenoh can autonomously search for communication partner nodes like DDS.\nBetween different networks, Zenoh can search for nodes through a broker (called a router in Zenoh) like MQTT.\nAlso, Zenoh provides functions for database operations and computational processing based on the Key-Value Store.\nMoreover, it has plugins/bridges for interoperability with MQTT, DDS, REST, etc. as communication middleware, and influxdb, RocksDB, etc. as database stacks.\n\nFor more details about Zenoh, please refer to the official resources.\n\n- [Official Page](https://zenoh.io/)\n- [GitHub](https://github.com/eclipse-zenoh/zenoh)\n- [Discord](https://discord.gg/vSDSpqnbkm)\n\nZenoh's core modules are implemented in Rust, but API libraries in various programming languages such as Python ([zenoh-python](https://github.com/eclipse-zenoh/zenoh-python)), C ([zenoh-c](https://github.com/eclipse-zenoh/zenoh-c)), C++ ([zenoh-cpp](https://github.com/eclipse-zenoh/zenoh-cpp)) are officially provided.\n\nSo what we need is [Elixir](https://elixir-lang.org/)!\nWith this library, you can call Zenoh from your Elixir application to perform its basic processing.\nThis allows the creation and communication of a large number of fault-tolerant nodes with little memory load (we hope :D","ref":"readme.html"},{"type":"extras","title":"Usage - Zenohex","doc":"**Currently, Zenohex uses version 0.10.1-rc of Zenoh.  \nWe recommend you use the same version to communicate with other Zenoh clients or routers.**\n\n#","ref":"readme.html#usage"},{"type":"extras","title":"Installation - Zenohex","doc":"`zenohex` is [available in Hex](https://hex.pm/packages/zenohex).\n\nYou can install this package into your project by adding `zenohex` to your list of dependencies in `mix.exs`:\n\n```elixir\n  defp deps do\n    [\n      ...\n      {:zenohex, \"~> 0.2.0\"},\n      ...\n    ]\n  end\n```\n\nDocumentation is also [available in HexDocs](https://hexdocs.pm/zenohex).\n\nZenohex can be also adapted to your [Nerves](https://nerves-project.org/) application just by adding `zenohex` in `mix.exs`.\nPlease refer to [pojiro/zenohex_on_nerves](https://github.com/pojiro/zenohex_on_nerves) as the example.\n\nThis repository uses [Rustler](https://github.com/rusterlium/rustler) to call Rust (Zenoh) modules from Elixir, and pre-compiled NIF modules are automatically downloaded at `mix compile` time (since v0.1.3).\nIOW, if you just want to use this library from your Elixir application, you do not need to prepare a Rust environment.\nIf you still want to build Rust NIF modules locally, please refer to [this section](#build-nif-module-locally).\n\n#","ref":"readme.html#installation"},{"type":"extras","title":"Getting Started - Zenohex","doc":"Zenohex has a policy of providing APIs that wrap the basic functionality of Zenoh like other API libraries.\n\nHere is the first step to building an Elixir application and using this feature.\n\n```sh\n$ mix deps.get\n$ mix compile\n$ iex -S mix\n```\n\n```elixir\niex()> {:ok, session} = Zenohex.open()\n{:ok, #Reference<>}\niex()> {:ok, publisher} = Zenohex.Session.declare_publisher(session, \"demo/example/test\")\n{:ok, #Reference<>}\niex()> {:ok, subscriber} = Zenohex.Session.declare_subscriber(session, \"demo/**\")\n{:ok, #Reference<>}\niex()> Zenohex.Publisher.put(publisher, \"Hello Zenoh Dragon\")\n:ok\niex()> Zenohex.Subscriber.recv_timeout(subscriber, 1000)\n{:ok,\n %Zenohex.Sample{\n   key_expr: \"demo/example/test\",\n   value: \"Hello Zenoh Dragon\",\n   kind: :put,\n   reference: #Reference<>\n }}\niex()> Zenohex.Subscriber.recv_timeout(subscriber, 1000)\n{:error, :timeout}\n```\n\n#","ref":"readme.html#getting-started"},{"type":"extras","title":"Practical examples - Zenohex","doc":"We implemented practical examples under the [lib/zenohex/examples](https://github.com/b5g-ex/zenohex/tree/main/lib/zenohex/examples).\nSince they consist of `Supervisor` and `GenServer`, we think they are useful as examples of more Elixir-like applications.\n\nPlease read the [lib/zenohex/examples/README.md](https://github.com/b5g-ex/zenohex/tree/main/lib/zenohex/examples/README.md) to use them as your implementation's reference.","ref":"readme.html#practical-examples"},{"type":"extras","title":"For developers - Zenohex","doc":"For most users, this section should be skipped.\n\n#","ref":"readme.html#for-developers"},{"type":"extras","title":"Build NIF module locally - Zenohex","doc":"This subsection is for developers who want to build NIF module locally in your Elixir application or try to use this repository itself for the contribution (very welcome!!).\n\nFirst, please install and configure the Rust environment according to [the instructions on the official site](https://www.rust-lang.org/tools/install).\n\nThen, add the following to your config file (e.g., `config/config.exs`) or make sure it is added.\n\n```elixir\nimport Config\n\nconfig :rustler_precompiled, :force_build, zenohex: true\n```\n\nWhen you want to build NIF module locally into your project, install Rustler by adding `rustler` to your list of dependencies in `mix.exs`:\n\n```elixir\n  defp deps do\n    [\n      ...\n      {:zenohex, \"~> 0.2.0\"},\n      {:rustler, \">= 0.0.0\", optional: true},\n      ...\n    ]\n  end\n```\n\n#","ref":"readme.html#build-nif-module-locally"},{"type":"extras","title":"Enhance mix test - Zenohex","doc":"This subsection describes some Tips for `mix test`.\n\nThe default `mix test` rebuilds the NIF module, so you can reduce the test time by doing the following in advance.\n\n```sh\nexport API_OPEN_SESSION_DELAY=0 && mix compile --force\n```\n\nYou can also reduce the test time by adjusting `SCOUTING_DELAY` as the follow.\n\n```sh\nSCOUTING_DELAY=30 mix test\n```\n\nThis parameter is used to set the upper time limit for searching (scouting) for a communication peer node.\nThe default value (when undefined) is 200 ms.\nIOW, if the test fails because the communication partner is not found within the set time, this value should be increased.\n\nFinally, the default `mix test` only checks the communication of Zenoh nodes within the same session.\nIf you wish to run communication tests between different sessions, please run the following.\n\n```sh\nUSE_DIFFERENT_SESSION=\"1\" mix test\n```\n\nFYI, CI does this in `test-with-another-session`.\nThis test may fail on GHA depending on whether the scouting is successful or not.\n\n#","ref":"readme.html#enhance-mix-test"},{"type":"extras","title":"How to release - Zenohex","doc":"These steps just follow the [Recommended flow of rustler_precompiled](https://hexdocs.pm/rustler_precompiled/precompilation_guide.html#recommended-flow).\n\n1. Change versions, `mix.exs`, `native/zenohex_nif/Cargo.toml`\n2. Run test, this step changes `native/zenohex_nif/Cargo.lock` version\n3. Commit them and put the version tag, like v0.2.0\n4. Puth the tag, like `git push origin v0.2.0`. This step triggers the `.github/workflows/nif_precompile.yml`\n5. After the artifacts are made, run `mix rustler_precompiled.download Zenohex.Nif --all` to update `checksum-Elixir.Zenohex.Nif.exs` and commit it\n6. Then publish to Hex","ref":"readme.html#how-to-release"},{"type":"extras","title":"Resources - Zenohex","doc":"- Zenoh meets Elixir in Japan\n  - presented in [Zenoh User Meeting 2023](https://www.zettascale.tech/news/zenoh-user-meeting-2023/) at 2023/12/12\n  - [SpeakerDeck](https://speakerdeck.com/takasehideki/zenoh-meets-elixir-in-japan)\n  - [YouTube archive](https://www.youtube.com/watch?v=4TYn_l6rXIg)\n- Zenohex: an eloquent, scalable and fast communication library for Elixir\n  - (will be) presented in [Code BEAM America 2024](https://codebeamamerica.com/) at 2024/03/07\n  - Slide and video archive will be added","ref":"readme.html#resources"},{"type":"extras","title":"License - Zenohex","doc":"The source code of this repository itself is published under [MIT License](https://github.com/b5g-ex/zenohex/blob/main/LICENSE).  \nPlease note that this repository mainly uses [Zenoh which is licensed under Apache 2.0 and EPL 2.0](https://github.com/eclipse-zenoh/zenoh/blob/main/LICENSE) and [Rustler which is licensed under either of Apache 2.0 or MIT](https://github.com/rusterlium/rustler?tab=readme-ov-file#license).","ref":"readme.html#license"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2023 b5g-ex\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"}],"content_type":"text/markdown"}